from gi.repository import Gtk
from gi.repository import GdkPixbuf
from gi.repository import Gdk

IMAGE_ID = 100


def _destroy_cb(widget, data=None):
    Gtk.main_quit()


def drag_begin_event(widget, context):
    print 'drag_begin_event'
    widget.drag_source_set_icon_pixbuf(widget.get_child().get_pixbuf())


def drag_data_get_event(widget, drag_context, data, info, time):
    print 'drag_data_get_event'
    # if info == IMAGE_ID:
    #     data.set_pixbuf(widget.get_child().get_pixbuf())
    data.set_pixbuf(widget.get_child().get_pixbuf())


def drag_data_received_event(widget, drag_context,
                             x, y, data, info, time):
    print 'drag_data_received_event'
    widget.set_from_pixbuf(data.get_pixbuf())


window = Gtk.Window()
window.connect("destroy", _destroy_cb)

image = Gtk.Image()
imagebuf = GdkPixbuf.Pixbuf.new_from_file('apple-red.png')
image.set_from_pixbuf(imagebuf)

imagebox = Gtk.EventBox()
imagebox.add(image)

imagebox.drag_source_set(Gdk.ModifierType.BUTTON1_MASK, [],
                         Gdk.DragAction.COPY)

imagebox.connect('drag-begin', drag_begin_event)
imagebox.connect('drag-data-get', drag_data_get_event)
# imagebox.drag_source_set_target_list(None)
imagebox.drag_source_add_image_targets()

destination_image = Gtk.Image()

destination_image.drag_dest_set(Gtk.DestDefaults.ALL, [], Gdk.DragAction.COPY)
destination_image.connect('drag-data-received', drag_data_received_event)
# destination_image.drag_dest_set_target_list(None)
destination_image.drag_dest_add_image_targets()

# targets = Gtk.TargetList.new([])
# targets.add_image_targets(IMAGE_ID, True)

# destination_image.drag_dest_set_target_list(targets)
# imagebox.drag_source_set_target_list(targets)

imagebuf = GdkPixbuf.Pixbuf.new_from_file('gnome-foot.png')
destination_image.set_from_pixbuf(imagebuf)

hbox = Gtk.Box(orientation=Gtk.Orientation.HORIZONTAL)
hbox.add(imagebox)
hbox.add(destination_image)

window.add(hbox)

window.show_all()
Gtk.main()
